slow_threshold = 5
safe_stop_headway = 15
forward_horizon = 100
cruise_speed = 13.9
last_target_speed = cruise_speed
lane_width = 4.5
time_threshold = 0.5
timestep = 0.05

in_lane = filter(lambda x: abs(x.position.y) < lane_width / 2, objects)
within_horizon = filter(lambda x: x.position.x < forward_horizon, in_lane)
slow = list(filter(lambda x: x.speed < slow_threshold, within_horizon))

if len(slow) > 0:
    closest_agent = sorted(slow, key=lambda x: x.position.x)[0]

    distance_to_closest = distance_to_closest_agent_vertex(closest_agent)
    distance_to_safe = distance_to_closest - safe_stop_headway

    if distance_to_safe < 0.1:
        target_speed = 0
    else:
        speed_of_closest = closest_agent.speed

        if speed_of_closest < 0.5:
            speed_of_closest = 0

        accel = (speed_of_closest ** 2 - last_target_speed ** 2) / (2 * distance_to_safe)
        target_speed = last_target_speed + accel * timestep

else:
    target_speed = last_target_speed + target_accel * timestep
